aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--development.mdwn4
-rwxr-xr-xlib/keyringer/actions/teardown27
-rwxr-xr-xlib/keyringer/functions13
-rw-r--r--share/man/keyringer.1.mdwn4
4 files changed, 42 insertions, 6 deletions
diff --git a/development.mdwn b/development.mdwn
index 1f475b6..8366b59 100644
--- a/development.mdwn
+++ b/development.mdwn
@@ -102,9 +102,7 @@ Setup:
Teardown:
- rm -rf ~/code/tests/keyringer
- rm ~/.keyringer/test
- sed -i -e '/^test=/d' ~/.keyringer/config
+ keyringer test teardown -y
Translation
-----------
diff --git a/lib/keyringer/actions/teardown b/lib/keyringer/actions/teardown
new file mode 100755
index 0000000..3d33da4
--- /dev/null
+++ b/lib/keyringer/actions/teardown
@@ -0,0 +1,27 @@
+#!/bin/bash
+#
+# Remove a keyring.
+#
+
+# Load functions
+LIB="`dirname $0`/../functions"
+source "$LIB" || exit 1
+
+# Options
+CONFIRM="$2"
+
+if [ -z "$CONFIRM" ] || [ "$CONFIRM" != "-y" ]; then
+ echo "WARNING: about to remove the LOCAL copy of $KEYRING"
+ echo "WARNING: This will irrevocably destroy $KEYDIR"
+ echo "WARNING: the action cannot be undone!"
+
+ read -rep "Are you sure to WIPE keyring $KEYRING (type YES to confirm)? " key
+ if [ "$key" != "YES" ]; then
+ exit 1
+ fi
+fi
+
+# Teardown
+keyringer_shred `dirname $KEYDIR`
+keyringer_shred $HOME/.keyringer/$KEYRING
+sed -i -e "/^$KEYRING=/d" $HOME/.keyringer/config
diff --git a/lib/keyringer/functions b/lib/keyringer/functions
index 872dac9..0e795ee 100755
--- a/lib/keyringer/functions
+++ b/lib/keyringer/functions
@@ -206,10 +206,17 @@ function keyringer_shred {
echo "$message $path using $tool..."
if [ -d "$path" ]; then
- find $path -exec $tool -f {} \;
- rmdir $path
+ if [ "$tool" == "wipe" ] || [ "$tool" == "rm" ]; then
+ $tool -rf $path
+ else
+ find $path -exec $tool -uf {} \;
+ fi
else
- $tool -f "$path"
+ if [ "$tool" == "wipe" ] || [ "$tool" == "rm" ]; then
+ $tool -f "$path"
+ else
+ $tool -uf "$path"
+ fi
fi
}
diff --git a/share/man/keyringer.1.mdwn b/share/man/keyringer.1.mdwn
index f8d243e..ad9569b 100644
--- a/share/man/keyringer.1.mdwn
+++ b/share/man/keyringer.1.mdwn
@@ -74,6 +74,10 @@ shell
All <*secret*> parameters from actions invoked from the shell are called
relatively from the current selected directory.
+teardown
+: Remove permanently a local copy of a repository, very dangerous if you
+ have just a single copy.
+
# SECRET MANIPULATION ACTIONS
All secret manipulation actions operate upon a *secret* which is the pathname